#!/usr/bin/gnuplot
#
# gnuplot Datei (gnuplot - an interactive plotting program) für Version 5.0
# (ausführbare Datei)
#
#
# Autor: Michael Krause
#
#====================================
#Vierquadrantendarstellung des BC547:
#====================================


#Setze 1 für das Anzeigen jeweiliger Kennlinien (nur eine 1)
zeige_Ausgangskennlinien = 0
zeige_Vorlage = 0
zeige_Auf_3_a = 0
zeige_Loesung = 1

set terminal wxt size 800, 800



#Labels für Ausgangskennlinien:
set grid xtics ytics
set label "50{/Symbol m}A" at 13,12
set label "100{/Symbol m}A" at 13,28
set label "150{/Symbol m}A" at 13,38
set label "200{/Symbol m}A" at 13,53
set label "250{/Symbol m}A" at 13,63
set label "300{/Symbol m}A" at 11,75
set label "350{/Symbol m}A" at 9,80
set label "400{/Symbol m}A" at 9,88
set border 3
set xtics axis
set ytics axis
set label 30 "U_{CE} in V" at 17.5,4.5
set label 31 "I_C in mA" at 0.4,97
set label "Ausgangskennlinien" at 15, 86 front nopoint tc lt 6

unset key

#Ausgangskennlinien mit Verlustleistungshyperpel
#====================================
if (zeige_Ausgangskennlinien > 0) {
	plot [0:20] [0:100] 'Ausgangskennlinie8.txt' w l lc rgb 'black' title '400{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie7.txt' w l lc rgb 'black' title '350{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie6.txt' w l lc rgb 'black' title '300{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie5.txt' w l lc rgb 'black' title '250{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie4.txt' w l lc rgb 'black 'title '200{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie3.txt' w l lc rgb 'black' title '150{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie2.txt' w l lc rgb 'black' title '100{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie1.txt' w l lc rgb 'black' title '50{/Symbol m}A' smooth sbezier ,'Verlusthyperpel.txt' w l lc rgb 'black ' smooth sbezier
}

#Lösung Aufgabe 3.1 GdTI-2018
#====================================
if (zeige_Auf_3_a > 0) {
	set multiplot
	set label "R_C=166\Ohm" at 12,3


	plot [0:20] [0:100] 'Ausgangskennlinie8.txt' w l lc rgb 'black' title '400{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie7.txt' w l lc rgb 'black' title '350{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie6.txt' w l lc rgb 'black' title '300{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie5.txt' w l lc rgb 'black' title '250{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie4.txt' w l lc rgb 'black 'title '200{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie3.txt' w l lc rgb 'black' title '150{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie2.txt' w l lc rgb 'black' title '100{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie1.txt' w l lc rgb 'black' title '50{/Symbol m}A' smooth sbezier , -(1000.0/166.7)*x+60 w l lc rgb 'blue'

	unset multiplot
}

#Vorlage mit Eingangs und Ausgangskennlinienfeldern
#====================================
if (zeige_Vorlage > 0) {
  
   	set multiplot layout 2,2 rowsfirst

	# first plot left side top
	set rmargin at screen 0.5
	set lmargin at screen 0.05
	set tmargin at screen 0.95
	set bmargin at screen 0.5

	unset label
	set border 1
	
	plot [-400:0] [0:100] 0#'Stromsteuerkennlinie_817.txt' w l lc rgb 'blue'

	set label "50{/Symbol m}A" at 13,12
	set label "100{/Symbol m}A" at 13,28
	set label "150{/Symbol m}A" at 13,38
	set label "200{/Symbol m}A" at 13,53
	set label "250{/Symbol m}A" at 13,63
	set label "300{/Symbol m}A" at 11,75
	set label "350{/Symbol m}A" at 9,80
	set label "400{/Symbol m}A" at 9,88
	set label 30 "U_{CE} in V" at 17.5,4.5
	set label 31 "I_C in mA" at 0.4,97
	set label "Ausgangskennlinien" at 12, 86 front nopoint tc lt 6
	set label "Stromsteuerkennlinien" at -20, 90 front nopoint tc lt 6
	set label "I_B in {/Symbol m}A" at -20,5
	set border 19

	#second plot right side top
	set lmargin at screen 0.5
	set rmargin at screen 0.95
	set tmargin at screen 0.5
	set bmargin at screen 0.95

	plot [0:20] [0:100] 'Ausgangskennlinie8.txt' w l lc rgb 'black' smooth sbezier , 'Ausgangskennlinie7.txt' w l lc rgb 'black' smooth sbezier , 'Ausgangskennlinie6.txt' w l lc rgb 'black' smooth sbezier , 'Ausgangskennlinie5.txt' w l lc rgb 'black' smooth sbezier , 'Ausgangskennlinie4.txt' w l lc rgb 'black ' smooth sbezier , 'Ausgangskennlinie3.txt' w l lc rgb 'black' smooth sbezier , 'Ausgangskennlinie2.txt' w l lc rgb 'black' smooth sbezier , 'Ausgangskennlinie1.txt' w l lc rgb 'black' smooth sbezier

	#third plot bottom left
	set lmargin at screen 0.05
	set rmargin at screen 0.5
	set tmargin at screen 0.5
	set bmargin at screen 0.05

        set xtics format " "
	set border 8
	set label "Eingangskennlinie" at -350, -0.2 front nopoint tc lt 6
	set label "U_{BE} in V" at 2,-0.75
	plot [-400:0] [-0.8:0] 'Eingangskennlinie.txt' w l lc rgb 'red' smooth sbezier 
	unset multiplot

}

#Lösung Aufgabe 3 GdTI-2018
#====================================
if (zeige_Loesung > 0) {
   	set multiplot layout 2,2 rowsfirst

	# first plot left side top
	set rmargin at screen 0.5
	set lmargin at screen 0.05
	set tmargin at screen 0.95
	set bmargin at screen 0.5

	unset label
	set border 1
	unset ytics
	
	plot [-400:0] [0:100] 'Stromsteuerkennlinie_166.txt' w l lc rgb 'purple' smooth sbezier
	
	set ytics

	set label "50{/Symbol m}A" at 13,12
	set label "100{/Symbol m}A" at 13,28
	set label "150{/Symbol m}A" at 13,38
	set label "200{/Symbol m}A" at 13,53
	set label "250{/Symbol m}A" at 13,63
	set label "300{/Symbol m}A" at 11,75
	set label "350{/Symbol m}A" at 9,80
	set label "400{/Symbol m}A" at 9,88
	set label 30 "U_{CE} in V" at 17.5,4.5
	set label 31 "I_C in mA" at 0.4,97
	set label "Ausgangskennlinien" at 12, 86 front nopoint tc lt 6
	set label "R_C=166 \Ohm" at 12,3
	set label "Stromsteuerkennlinien" at -20, 90 front nopoint tc lt 6
	set label "I_B in {/Symbol m}A" at -20,5
	set border 19

	#second plot right side top
	set lmargin at screen 0.5
	set rmargin at screen 0.95
	set tmargin at screen 0.5
	set bmargin at screen 0.95

	plot [0:20] [0:100] 'Ausgangskennlinie8.txt' w l lc rgb 'black' title '400{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie7.txt' w l lc rgb 'black' title '350{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie6.txt' w l lc rgb 'black' title '300{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie5.txt' w l lc rgb 'black' title '250{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie4.txt' w l lc rgb 'black 'title '200{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie3.txt' w l lc rgb 'black' title '150{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie2.txt' w l lc rgb 'black' title '100{/Symbol m}A' smooth sbezier , 'Ausgangskennlinie1.txt' w l lc rgb 'black' title '50{/Symbol m}A' smooth sbezier , -(1000.0/166.7)*x+60 w l lc rgb 'blue','Verlusthyperpel.txt' w l lc rgb 'black' smooth sbezier


	#third plot bottom left
	set lmargin at screen 0.05
	set rmargin at screen 0.5
	set tmargin at screen 0.5
	set bmargin at screen 0.05

	unset xtics
	set border 8
	set label "Eingangskennlinie" at -350, -0.2 front nopoint tc lt 6
	set label "U_{BE} in V" at -60,-0.75
	plot [-400:0] [-0.8:0] 'Eingangskennlinie.txt' w l lc rgb 'red' smooth sbezier
	set xtics
	unset multiplot
}

pause -1
