#!/usr/bin/gnuplot
#
# gnuplot Datei (gnuplot - an interactive plotting program) für Version 5.0
# (ausführbare Datei) 
#
#
# Autor: Michael Krause
#
#====================================
#Eingangskennlinie des BC547:
#====================================

print_in_3rd_quadrant = 0

set xtics axis
set ytics axis
unset key

if (print_in_3rd_quadrant > 0) {
    set border 44
    set label "I_B in .{/Symbol m}A" at -400,-0.08
    set label "U_{BE} in V" at -50,-0.75
    set label "Eingangskennlinie" at -350, -0.2 front nopoint tc lt 6

    plot [-400:0] [-0.8:0] 'Eingangskennlinie.txt' w l lc rgb 'red' smooth sbezier 
}
else {
    set border 3
    set label "I_B in .{/Symbol m}A" at 0.015,382
    set label "U_{BE} in V" at 0.73,20
    set label "Eingangskennlinie" at 0.2,310 front nopoint tc lt 6

    plot [0:0.8] [0:400] 'Eingangskennlinie_positiv.txt' w l lc rgb 'red' smooth sbezier,(1000000/420)*x-1359.52 #420 Ohm = Differentieller Widerstand
}


pause -1
